#include <bits/stdc++.h>

#define int int64_t

signed main()
{
  std::ios::sync_with_stdio(false);
  std::cin.tie(0);
  int n, q;
  std::cin >> n >> q;
  std::vector<char> a(n + 1);
  for(int i = 1; i <= n; i++) {
    std::cin >> a[i];
  }
  while(q--) {
    int l, r;
    std::cin >> l >> r;
    int ans = 0;
    for(int x = l; x <= r; x++) {
      int cnt = 0;
      int suf = 0;
      for(int i = r; i >= l; i--) {
        if(i >= x) {
          if(a[i] == '?' || a[i] == '7') {
            suf += 1;
          }
        }
        else {
          if(a[i] == '6' || a[i] == '?') {
            cnt += suf;
          }
          else {
            suf += 1;
          }
        }
      }
      ans = std::max(ans, cnt);
    }
    std::cout << ans << "\n";
  }
}